/* agentport.h
 * 
 */

#ifndef _AGENTPORT_H_
#define _AGENTPORT_H_ 1

/* stifle unavoidable compiler warnings */
#pragma warning(disable: 4244 4310 4115 4055 4054 4127 4100 )

#include <windows.h>

#include <ctype.h>   /* for "isdigit()" */
#include <stdio.h>
#include <stdlib.h>   /* for atoi(), exit() */
#include <string.h>

#define NNSQUAD 1
#ifdef NNSQUAD
/* ifdeffable per-port option switches */
//#define OMIT_CONNECTIONS    1   /* Connection recording option */
#define WEBIO_GUI         1   /* Maintain images for GUI */
#define POP3_MONITOR      1   /* Watch POP connections in detail */
#define BLOCKING_LOG      1   /* log blocks to toolbar or window */
#define DNS_REVLOOKUPS    1   /* Do reverse DNS name lookups */
//#define VIRUS_CHECK       1   /* Build does virus checking */
//#define SMTP_ALERTS       1   /* System has SMTP alert option */
//#define PI_SITEADVISOR    1   /* Support Site Advisor Plung-in */
//#define BR_COMMUNITIES    1   /* Get blocking DBs from online communities */

#else

/* ifdeffable per-port option switches */
//#define OMIT_CONNECTIONS    1   /* Connection recording option */
//#define SMTP_ALERTS       1   /* System has SMTP alert option */
#define WEBIO_GUI         1   /* Maintain images for GUI */
#define VIRUS_CHECK       1   /* Build does virus checking */
#define POP3_MONITOR      1   /* Watch POP connections in detail */
#define BLOCKING_LOG      1   /* log blocks to toolbar or window */
#define DNS_REVLOOKUPS    1   /* Do reverse DNS name lookups */
#define PI_SITEADVISOR    1   /* Support Site Advisor Plung-in */
#define BR_COMMUNITIES    1   /* Get blocking DBs from online communities */

#endif


#define u_long unsigned long
#define u_char unsigned char
#define unshort unsigned short
#define u_short unsigned short

#define  MEMCPY(dest, src, ct)      memcpy(dest, src, ct)
#define  MEMSET(dest, val, ct)      memset(dest, val, ct)
#define  MEMMOVE(dest, src, ct)     memmove(dest, src, ct)
#define  MEMCMP(dest, src, ct)      memcmp(dest, src, ct)


#define stristr(s1, s2) _stristr(s1, s2)

#define MAXNETS     12
#define MAXDNSNAME  256


#ifndef TRUE
#define TRUE   -1
#endif

#ifndef FALSE
#define FALSE   0
#endif

#ifndef NULL
#define NULL ((void*)0)
#endif   /* NULL */


extern unsigned long cticks;  /* clock ticks since startup */

#define TPS        18  /* cticks per second */


extern unsigned long lswap(unsigned long l); /* swap bytes in 32 bit long */
#define htonl(l) lswap(l)
#define ntohl(l) lswap(l)
#ifdef  IP_TTL           /* defined in a Microsoft C Compiler file */
#undef  IP_TTL           /* will be redefined */
#endif  
#define IP_TTL        64 /* define IP hop count for this port */

#define htons(s) ((u_short)((u_short)(s) >> 8) | (u_short)((u_short)(s) << 8))
#define ntohs(s) htons(s)
 
#define socketclose(socket) closesocket(socket)
#define sock_errno(socket)  WSAGetLastError()

long atol(const char * txt); /* don't let compiler truncate longs */

void * npalloc(unsigned);
void   npfree(void*);

#define  PL_ALLOC(size)		npalloc(size)
#define  PL_FREE(ptr)		npfree(ptr)
#define  CN_ALLOC(size)		npalloc(size)
#define  CN_FREE(ptr)		npfree(ptr)
#define  BTN_ALLOC(size)	npalloc(size)
#define  BTN_FREE(ptr)		npfree(ptr)
#define  IPH_ALLOC(size)	npalloc(size)
#define  IPH_FREE(ptr)		npfree(ptr)
#define  HOST_ALLOC(size)	npalloc(size)
#define  HOST_FREE(ptr)		npfree(ptr)
#define  CP_ALLOC(size)		npalloc(size)
#define  CP_FREE(ptr)		npfree(ptr)
#define  PEP_ALLOC(size)	npalloc(size)
#define  PEP_FREE(ptr)		npfree(ptr)
#define  DN_ALLOC(size)		npalloc(size)
#define  DN_FREE(ptr)		npfree(ptr)
#define  POPC_ALLOC(size)	npalloc(size)
#define  POPC_FREE(ptr)		npfree(ptr)
#define  AL_ALLOC(size)		npalloc(size)
#define  AL_FREE(ptr)		npfree(ptr)
#define  LM_ALLOC(size)		npalloc(size)
#define  LM_FREE(ptr)		npfree(ptr)
#define  BT_ALLOC(size)		npalloc(size)
#define  BT_FREE(ptr)		npfree(ptr)
#define  PL_ALLOC(size)		npalloc(size)
#define  PL_FREE(ptr)		npfree(ptr)
#define  SA_ALLOC(size)		npalloc(size)
#define  SA_FREE(ptr)		npfree(ptr)
#define  IMG_ALLOC(size)	npalloc(size)
#define  IMG_FREE(ptr)		npfree(ptr)
#define  CTD_ALLOC(size)	npalloc(size)
#define  CTD_FREE(ptr)		npfree(ptr)
#define  CTT_ALLOC(size)	npalloc(size)
#define  CTT_FREE(ptr)		npfree(ptr)
#define  DNM_ALLOC(size)	npalloc(size)
#define  DNM_FREE(ptr)		npfree(ptr)
#define  PTH_ALLOC(size)	npalloc(size)
#define  PTH_FREE(ptr)		npfree(ptr)
#define  WD_ALLOC(size)	    npalloc(size)
#define  WD_FREE(ptr)		npfree(ptr)
#define  PB_ALLOC(size)	    npalloc(size)
#define  PB_FREE(ptr)		npfree(ptr)
#define  CD_ALLOC(size)	    npalloc(size)
#define  CD_FREE(ptr)		npfree(ptr)
#define  LAN_ALLOC(size)	npalloc(size)
#define  LAN_FREE(ptr)		npfree(ptr)
#define  PK_ALLOC(size)		npalloc(size)
#define  PK_FREE(ptr)		npfree(ptr)
#define  PKL_ALLOC(size)    npalloc(size)
#define  PKL_FREE(ptr)		npfree(ptr)
#define  PKS_ALLOC(size)    npalloc(size)
#define  PKS_FREE(ptr)		npfree(ptr)
#define  OBP_ALLOC(size)    npalloc(size)
#define  OBP_FREE(ptr)		npfree(ptr)
#define  AT_ALLOC(size)    npalloc(size)
#define  AT_FREE(ptr)		npfree(ptr)


void wintrap(char *, int);

/* Microsoft compiler only generates file & line numbers if compiling
 * a debug build. Adjust dtrap() accordingly.
 */
#ifdef _DEBUG
#define dtrap()  wintrap(__FILE__, __LINE__)
#else
#define dtrap()  dprintf("dtrap");
#endif


#define TH_OBJECT(name)       HANDLE name
#define TH_OBJECT_PTR(name)   HANDLE * name


/* Windows exception catching thread wrappers with try/except logic */
#define TH_PROTO(name)    DWORD WINAPI name(void* p)

#define REMOTE_EXEPTIONS 1

#ifdef REMOTE_EXEPTIONS

#define TH_ENTRY(name)  \
       DWORD WINAPI name(void * parm) \
       { __try{

#define TH_EXIT(name)  \
  } __except(RecordExceptionInfo(GetExceptionInformation(), name )) \
	{  exit(-1);  } return 0; }

extern int   RecordExceptionInfo(PEXCEPTION_POINTERS, char * caller);

#else
#define TH_ENTRY(name) DWORD WINAPI name(void * parm)
#define TH_EXIT(name)
#endif  /* REMOTE_EXEPTIONS */

extern   int   TH_WAKE(long);
extern   void  TH_SLEEP(long);
extern   void  TH_BLOCK(void);

void TH_LOCK_MUTEX( void * mutexptr);
void TH_UNLOCK_MUTEX( void * mutexptr);

#ifndef _INC_WINDOWS             /* from windows.h */
extern   long  to_pingcheck;
#endif   /* _INC_WINDOWS */

#define MAC_HDRLEN  14      /* Ethernet header size */


extern   int  br_kbhit(void);
extern   int  br_getkey(void);
extern   void  br_winexit(int code, int restart);

#define PORT_EXIT_FUNC(err) br_winexit(err, 0)

#define MEM_WRAPPERS    1

#define TH_RETURN_OK()     { USE_ARG(parm); ExitThread(0); return (1); }  
#define TH_RETURN_ERROR()  { USE_ARG(parm); ExitThread(1); return (0); }
#define TH_RETURN_UNREACHABLE()  { parm=parm; panic("TH_ret_un");}

extern   int      TH_WAKE(long handle);
extern   int      TH_NEWTASK(struct br_thread *);

#define  NET_PRIORITY       1
#define  APP_PRIORITY       0
#define  NET_STACK_SIZE 8192
#define  APP_STACK_SIZE 8192     /* default for applications */


int bm_printf(void* io, char * format, ...);
void dprintf(char * format, ...);

/* map printfs into our own IO system */
#define printf dprintf


/* definitions for inet  */
#define LITTLE_ENDIAN 1234
#define BIG_ENDIAN    4321
#define BYTE_ORDER    LITTLE_ENDIAN

/* some maximum packet buffer numbers */
#define MAXBIGPKTS    100
#define MAXLILPKTS    100
#define MAXPACKETS    (MAXLILPKTS+MAXBIGPKTS)


/* macro to get rid of "unused argument" warnings. */

#define USE_ARG(x) {x = x;}



/* hooks to pass suspicious events from http code. */
extern int br_htproblem(int opcode, void * hp);
#define	HT_BADOPCODE	199

/* Time we should to allow for system startup */
#define  SYS_STARTUP_LAG   (3 * MINUTE)   /* Windoze - slow */

int	br_filecheck();	/* check non-vfs http "get" files */

extern int br_ifinet;   /* our current Internet iface */

/* Map BSD socket error to winsock values (overrides nptcp.h) */

#define SOCKERRORS_ALREADY      1

#define WSABASEERR              10000  /* Winsock error base */

/* Duplicate constant error returns from from winsock.h. This
 * are system error codes and thus should not change.
 */
#define WSAEWOULDBLOCK          (WSABASEERR+35)
#define WSAEINPROGRESS          (WSABASEERR+36)
#define WSAEALREADY             (WSABASEERR+37)
#define WSAEISCONN              (WSABASEERR+56)
#define WSAEINVAL               (WSABASEERR+22)
#define WSAETIMEDOUT            (WSABASEERR+60)
#define WSAECONNREFUSED         (WSABASEERR+61)
#define WSAECONNABORTED         (WSABASEERR+53)
#define WSAECONNRESET           (WSABASEERR+54)
#define WSAENOTCONN             (WSABASEERR+57)


/* Map to BSD for some hope of portability */
#define  EWOULDBLOCK             WSAEWOULDBLOCK
#define  EINPROGRESS             WSAEINPROGRESS
#define  EALREADY                WSAEALREADY
#define  EISCONN                 WSAEISCONN
#define  EINVAL                  WSAEINVAL
#define  ETIMEDOUT               WSAETIMEDOUT
#define  ECONNREFUSED            WSAECONNREFUSED
#define  ECONNABORTED            WSAECONNABORTED
#define  ECONNRESET              WSAECONNRESET
#define  ENOTCONN                WSAENOTCONN



struct br_thread
{
   TH_OBJECT_PTR(tk_ptr);  /* pointer to static task object */
   char * name;            /* name of task */
   LPTHREAD_START_ROUTINE entry;    /* pointer to code to start task at */
   int   priority;         /* priority of task */
   int   stacksize;        /* size (bytes) of task's stack */

   /* keep local table information for mapping windows Thread handles to
    * ThreadIDs. Any sane system would only have one or the other, not
    * both; but this is windows.
    */

   HANDLE   hThread;       /* Windows thread handle for this task */
   DWORD    ThreadId;      /* Windows thread "Id" for this task */

   void *   event;         /* for tcp_sleep()/tcp_wakeup() */
   int      sleep_level;   /* 0 or lower if task should run */
   HANDLE   winEvent;      /* Windows event for TK_BLOCK/TK_WAKE */
   int      state;         /* for task menu function */

   /* state transition counters */
   u_long   blocks;
   u_long   sleeps;
   u_long   wakes;
   u_long   yields;

   void *   critsec;       /* last critical section pointer */
   int      critnest;      /* depth into crit sections */

   /* Added parameter to pass iface numbers to NDIS threads */
   long     parameter;     /* Parameter to new thread */
};

/* keep an array of pointers to the task/thread structures above */
#define  MAXTHREADS   14
extern struct br_thread * winthreads[MAXTHREADS];

/* get current TK task entry */
extern   struct br_thread *  br_currentTask(void);

/* definitions for br_thread->state */
#define TS_PREINIT      0
#define TS_SLEEPING     1
#define TS_IDLE         2
#define TS_BLOCKED      3
#define TS_RUNNING      4
#define TS_READY        5
#define TS_SOCKSLEEP    6
#define TS_WINMSG       7     /* blocked on windows GetMessage() */
#define TS_NDEVENT1     8     /* blocked on 1st Ndis receive event */
#define TS_NDEVENT2     9     /* blocked on 2nd Ndis receive event */
#define TS_NDRX         10    /* inside Ndis receive */
#define TS_NDSEND       11    /* blocked on Ndis send */
#define TS_MUTEXWAIT    12    /* waiting for LOCK_NET_RESOURCE */


extern HANDLE to_netmain;


/* Set a 1 second periodic callback timer */
extern  int     br_timerset( void (*func)(long parm), long msec, long parm );
extern  void    br_timerkill(int timer);    /* Kill timer */    

/* emulate linucks function */
int   gettimeofday( struct timeval *);


#endif /* _AGENTPORT_H_ */



